# Copyright 2018 - 2019 Virtru Corporation
#
# SPDX - License - Identifier: MIT
#

# sample encrypt/decrypt
import sys
from virtru_tdf3_python import Client, Policy, EncryptFileParam, LogLevel

# encrypt the file and apply the policy on tdf file and also decrypt.
try:
    # Create a client
    # TODO: Put your owner email and appId values here
    # client = Client(owner = "<owner-email-id>",
    #                 app_id = "<appid-token>")
    client.enable_console_logging(log_level = LogLevel.Error)

    # Create a simple policy that expires in 60 minutes
    policy = Policy()

    # TODO: Add any users if you would like to share the files with.
    # policy.share_with_users(["user1@example.com", "user2@example.com"])

    policy.expire_in_mins(mins = 60)
    #print(policy)

    # Create the encryption parameters
    param = EncryptFileParam(in_file_path = "sample.docx",
                             out_file_path = "sample.docx.html")

    # Create a default policy
    param.set_policy(policy)

    # Use the client and param info to encrypt the file
    policy_uuid = client.encrypt_file(encrypt_file_param = param)
    print("Policy uuid:%s" % (policy_uuid))

    # Use the client to decrypt the file
    client.decrypt_file(in_file_path = "sample.docx.html",
                        out_file_path = "sample_py.docx")
except:
    print("Unexpected error: %s" % sys.exc_info()[0])
    raise
